package ROTool::Client;
use strict;
use ROTool;
use vars qw(@ISA);

@ISA = qw( ROTool );

sub is_morph{
    # not a method

    # Please implement for each protocol, 
    # and add entry into ROTool::recv();
}

sub new{
    # please implement for each protocol if need.
    my $class = shift;
    my $self  = shift;
    
    $self->{"param"} = {};
    $self->{"timer"} = {};
    $self->{"state"} = {};
    $self->{"timer"}->{"shutdown"}= &ROTool::timeout();
    &main::printlog(" morph [$self->{oid}] into $class\n");

    return bless $self , $class;
}

sub is_client{
    return 1;
}

sub is_server{
    return 0;
}

sub recv{
    my $self = shift;
    # please implement for each protocol
}

sub send{
    my $self = shift;
    # please implement for each protocol
}

sub shutdown{
    # please implement for each protocol if need
    my $self = shift;
    my($selecter) = @_;

    my $sock = $self->{"sock"};
    if($self->{"Message_lasting"}){
	&ROTool::UA_unregist($self);
	&ROTool::client_unregist($self);
	&main::printlog(" unkeepmsg[$self->{oid}]\n");
    }elsif($self->is_keep_message()){
	&ROTool::sock_unregist($self);
	$selecter->remove($sock);
	$sock->shutdown(2);
	$self->keep_message();
	$self->{timer}->{shutdown} = &ROTool::keeptime();
	&main::printlog(" shutdown and keepmsg[$self->{oid}]\n");
    }else{
	&ROTool::sock_unregist($self);
	$selecter->remove($sock);
	$sock->shutdown(2);
	&ROTool::UA_unregist($self);
	&ROTool::client_unregist($self);
	&main::printlog(" shutdown [$self->{oid}]\n");
    }

}

sub keep_message{
    my $self = shift;
    $self->{"param"}->{"name"}  = "--";
    $self->{"param"}->{"area"}  = "no connect";
    $self->{"param"}->{"lv"}    = "--/--/--";
    $self->{"param"}->{"server"}= "--";
    $self->{"param"}->{"hp"}    = 0;
    $self->{"param"}->{"hpmax"} = 0;
    $self->{"param"}->{"SP"}    = 0;
    $self->{"param"}->{"MaxSP"} = 0;
    $self->{"Message_lasting"}  = 1;

}

sub checktimer{
    my $self = shift;
    my($selecter) = @_;

    my @result;
    $self->{timer}->{shutdown}--;
    if($self->{timer}->{shutdown} == 0){
	$self->shutdown($selecter);
    }
}

__END__

=head1 NAME

ROTool::Client - base module of ROTool clients.

=head1 DESCRIPTION
    
C<ROTool::Client> is base module of ROTool clients.

B<NOTICE> : Do not use C<ROTool::Client> as module or class.
C<ROTool::Client> is only super module of ROTool clients module.

=head1 STYLE GUIDELINE

